Summary: An extensible library providing authentication for applications
Name: pam
Version: 1.5.3
Release: 9%{?dist}
License: BSD and GPLv2+
URL: http://www.linux-pam.org
Source0: https://github.com/linux-pam/linux-pam/releases/download/v%{version}/Linux-PAM-%{version}.tar.xz
Source1: https://github.com/linux-pam/linux-pam/releases/download/v%{version}/Linux-PAM-%{version}.tar.xz.asc
Source2: config-util.pamd
Source3: other.pamd
Source4: system-auth.5
Source5: config-util.5
Source6: postlogin.5
Source7: pamtmp.conf
Source8: gpl-2.0.txt

Patch0001: pam-1.5.3-CVE-2024-22365.patch
#https://github.com/linux-pam/linux-pam/pull/854
#https://github.com/linux-pam/linux-pam/commit/940747f88c16e029b69a74e80a2e94f65cb3e628
Patch0002: pam-1.5.3-CVE-2024-10963.patch
#https://github.com/linux-pam/linux-pam/commit/b3020da7da384d769f27a8713257fbe1001878be
Patch0003: pam-1.5.3-CVE-2024-10041.patch
Patch0004: https://github.com/linux-pam/linux-pam/commit/76af6380776a81ffd6ff50de254fb448ec6bce79.patch
Patch0005: https://github.com/linux-pam/linux-pam/commit/d3b8c0723d0d691585474b0e14982f62b115a672.patch
Patch0006: https://github.com/linux-pam/linux-pam/commit/8295f092f6138ced15decc05e094667b0a8488e3.patch
Patch0007: https://github.com/linux-pam/linux-pam/commit/6bd4e4e54c2cdc38ce08436ac786330af72b6207.patch
Patch0008: https://github.com/linux-pam/linux-pam/commit/66106ea2c9c20c1c5c05f919b363ae6ca3e7d5ca.patch
Patch0009: https://github.com/linux-pam/linux-pam/commit/49b0b16a3d9781c6d7294b3d04a4d6d57b388c1b.patch
Patch0010: https://github.com/linux-pam/linux-pam/commit/28894b319488e8302899ee569b6e0911905f374e.patch
Patch0011: https://github.com/linux-pam/linux-pam/commit/0703453bec6ac54ad31d7245be4529796a3ef764.patch
Patch0012: https://github.com/linux-pam/linux-pam/commit/9e4e3e42554fc6344a0b20b42aafb48011e9b2c9.patch

Patch3000: pam-1.5.3-userdb-gdbm.patch
Patch5000: add-sm3-support.patch


BuildRequires: gcc, make, automake, autoconf, bison, flex, libtool, pkgconfig
BuildRequires: audit-libs-devel, gettext-devel, gdbm-devel, libeconf-devel, libnsl2-devel
BuildRequires: systemd, libselinux-devel, libtirpc-devel, libxcrypt-devel, openssl-devel >= 3.0.0
Requires: libpwquality, setup, authselect >= 1.3

%description
PAM (Pluggable Authentication Modules) is a security tool that allows setting authentication
policy without recompiling programs.

%package devel
Summary: Library for developing PAM-aware applications and modules for PAM
Requires: pam = %{version}-%{release}

%description devel
PAM is a security tool which allows setting authentication policy without recompiling programs.
This package contains header files used for building both PAM-aware applications and modules.

%prep
%autosetup -n Linux-PAM-%{version} -p1
cp %{SOURCE8} .

%build
%configure \
  --libdir=%{_libdir} \
  --includedir=%{_includedir}/security \
  --disable-rpath \
  --disable-static \
  --disable-prelude \
  --enable-audit \
  --enable-openssl \
  --enable-selinux \
  --enable-lastlog \
  --enable-db=gdbm
%make_build

%install
%make_install

install -d -m 755 %{buildroot}%{_sysconfdir}/pam.d
install -d -m 755 %{buildroot}%{_datadir}/pam.d
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/pam.d/other
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/config-util
install -d -m 755 %{buildroot}/var/run/faillock

for phase in auth acct passwd session ; do
  ln -sf pam_unix.so %{buildroot}%{_libdir}/security/pam_unix_${phase}.so
done
ln -sf pam_sepermit.so %{buildroot}%{_libdir}/security/pam_selinux_permit.so
install -m 644 -D modules/pam_namespace/pam_namespace.service \
  %{buildroot}%{_unitdir}/pam_namespace.service
install -m 600 /dev/null %{buildroot}%{_sysconfdir}/security/opasswd
install -m 644 -D %{SOURCE7} %{buildroot}%{_prefix}/lib/tmpfiles.d/pam.conf

install -m 644 %{SOURCE4} %{SOURCE5} %{SOURCE6} %{buildroot}%{_mandir}/man5/
ln -sf system-auth.5 %{buildroot}%{_mandir}/man5/password-auth.5
ln -sf system-auth.5 %{buildroot}%{_mandir}/man5/fingerprint-auth.5
ln -sf system-auth.5 %{buildroot}%{_mandir}/man5/smartcard-auth.5

rm -rf %{buildroot}%{_datadir}/doc/Linux-PAM
rm -f %{buildroot}%{_sysconfdir}/environment
rm -f %{buildroot}%{_libdir}/$libpam*.la
rm -f %{buildroot}%{_libdir}/security/*.la
rm -rf %{buildroot}/usr/share/doc/pam

install -d -m 755 %{buildroot}%{_pkgdocdir}
install -p -m 644 doc/specs/rfc86.0.txt %{buildroot}%{_pkgdocdir}
%find_lang Linux-PAM

%check
%make_build check || :

%files -f Linux-PAM.lang
%license Copyright
%license gpl-2.0.txt
%dir %{_sysconfdir}/pam.d
%dir %{_datadir}/pam.d
%config(noreplace) %{_sysconfdir}/pam.d/other
%config(noreplace) %{_sysconfdir}/pam.d/config-util
%{_libdir}/libpam.so.0*
%{_libdir}/libpamc.so.0*
%{_libdir}/libpam_misc.so.0*
%{_sbindir}/pam_namespace_helper
%{_sbindir}/faillock
%attr(4755,root,root) %{_sbindir}/pam_timestamp_check
%attr(4755,root,root) %{_sbindir}/unix_chkpwd
%attr(0700,root,root) %{_sbindir}/unix_update
%attr(0755,root,root) %{_sbindir}/mkhomedir_helper
%attr(0755,root,root) %{_sbindir}/pwhistory_helper
%dir %{_libdir}/security
%{_libdir}/security/*
%{_unitdir}/pam_namespace.service
%dir %{_sysconfdir}/security
%config(noreplace) %{_sysconfdir}/security/access.conf
%config(noreplace) %{_sysconfdir}/security/faillock.conf
%config(noreplace) %{_sysconfdir}/security/group.conf
%config(noreplace) %{_sysconfdir}/security/limits.conf
%dir %{_sysconfdir}/security/limits.d
%config(noreplace) %{_sysconfdir}/security/namespace.conf
%dir %{_sysconfdir}/security/namespace.d
%attr(755,root,root) %config(noreplace) %{_sysconfdir}/security/namespace.init
%config(noreplace) %{_sysconfdir}/security/pam_env.conf
%config(noreplace) %{_sysconfdir}/security/time.conf
%config(noreplace) %{_sysconfdir}/security/opasswd
%config(noreplace) %{_sysconfdir}/security/sepermit.conf
%config(noreplace) %{_sysconfdir}/security/pwhistory.conf
%dir /var/run/sepermit
%dir /var/run/faillock
%{_prefix}/lib/tmpfiles.d/pam.conf
%{_mandir}/man5/*
%{_mandir}/man8/*

%files devel
%dir %{_pkgdocdir}
%doc %{_pkgdocdir}/rfc86.0.txt
%{_includedir}/security
%{_mandir}/man3/*
%{_libdir}/libpam.so
%{_libdir}/libpamc.so
%{_libdir}/libpam_misc.so
%{_libdir}/pkgconfig/pam.pc
%{_libdir}/pkgconfig/pam_misc.pc
%{_libdir}/pkgconfig/pamc.pc

%changelog
* Thu Dec 26 2024 Tracker Robot <trackbot@opencloudos.tech> - 1.5.3-9
- Apply patches from rpm-tracker
- [Bug Fix] 9e4e3e42554fc6344a0b20b42aafb48011e9b2c9.patch: pam_env: remove escaped newlines from econf lines
- [Bug Fix] 0703453bec6ac54ad31d7245be4529796a3ef764.patch: pam_env: check VENDORDIR after config.h inclusion
- [Bug Fix] 28894b319488e8302899ee569b6e0911905f374e.patch: pam_env: fix --enable-vendordir fallback logic
- [Bug Fix] 49b0b16a3d9781c6d7294b3d04a4d6d57b388c1b.patch: pam_access: do not call pam_sm_authenticate
- [Bug Fix] 66106ea2c9c20c1c5c05f919b363ae6ca3e7d5ca.patch: pam_localuser: do not call pam_sm_authenticate
- [Bug Fix] 6bd4e4e54c2cdc38ce08436ac786330af72b6207.patch: pam_usertype: do not call pam_sm_authenticate
- [Bug Fix] 8295f092f6138ced15decc05e094667b0a8488e3.patch: pam_lastlog: do not call pam_sm_authenticate
- [Bug Fix] d3b8c0723d0d691585474b0e14982f62b115a672.patch: pam_unix: do not truncate user names
- [Bug Fix] 76af6380776a81ffd6ff50de254fb448ec6bce79.patch: pam_timestamp: correct failure condition

* Tue Dec 24 2024 wynnfeng <wynnfeng@tencent.com> - 1.5.3-8
- [Type] security
- [DESC] fix CVE-2024-10041

* Thu Nov 28 2024 wynnfeng <wynnfeng@tencent.com> - 1.5.3-7
- [Type] security
- [DESC] fix CVE-2024-10963

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.3-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.3-5
- Rebuilt for loongarch release

* Tue Jan 30 2024 wynnfeng <wynnfeng@tencent.com> - 1.5.3-4
- fix CVE-2024-22365

* Fri Jan 19 2024 Miaojun Dong <zoedong@tencent.com> - 1.5.3-3
- Enable (deprecated) pam_lastlog module
- Switch pam_userdb from BerkeleyDB to GDBM

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.3-2
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 02 2023 Miaojun Dong <zoedong@tencent.com> - 1.5.3-1
- Bump version to 1.5.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.2-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.2-3
- Rebuilt for OpenCloudOS Stream 23

* Mon Feb 20 2023 Miaojun Dong <zoedong@tencent.com> - 1.5.2-2
- Add sm3 support.

* Fri May 20 2022 TAO WU <tallwu@tencent.com> - 1.5.2-1
- Initial build.
